/* 変数型の定義 */
typedef enum {
  STP = 0,
  STR,
  ROT,
  MRK,
  ARK
} run_state_t;

typedef struct {
  unsigned char val[7];
} serial_data_t;

typedef struct {
  unsigned char val[6];
} middle_data_t;

typedef struct {
  signed short val[3];
} command_data_t;

/* ピン配置 */
#define PIN_ENC_A_L  2
#define PIN_ENC_B_L  5
#define PIN_ENC_A_R  3
#define PIN_ENC_B_R  4
#define PIN_ENC_A_M  8
#define PIN_ENC_B_M  7
#define PIN_DIR_R    15
#define PIN_PWM_R    10
#define PIN_DIR_L   16
#define PIN_PWM_L   9
#define PIN_DIR_M   14
#define PIN_PWM_M   11
#define PIN_PWM_LINE   6
#define PIN_DIR_LINE   12
#define PIN_BATT_A    18
#define PIN_BATT_B    19

/* パラメータ */
// 動作周期 [ms]
#define T_CTRL 10 

// タイヤ半径 [cm] 3.2
#define R_TIRE     4.387 
// タイヤ間隔 [cm] 25.0
#define D_TIRE    32.0
// エンコーダ分解能 (A相立上り/立下りを利用するため2倍)
#define ENC_RANGE (13*2) 
#define ENC_RANGE_M 11    //マーカー用モータ
// ギア比
#define T_E_RATIO 19.0   
// 右タイヤに対する左タイヤの回転比
#define L_R_RATIO 0.9865

// バッテリ入力の分圧比
#define V_RATIO 0.5 
