#完了画面
import wx
from datetime import datetime,timedelta,timezone
import time
import RPi.GPIO as GPIO

from .get_status import GetDate
from .gpio_setup import OK
from .exit_frame import ExitFrame

class FinishFrame(wx.Frame):
    def __init__(self,parent):
        wx.Frame.__init__(self,parent,-1,"finish")
        size=wx.ScreenDC().GetSize()
        self.SetSize(size)
        self.SetPosition(wx.Point(0,0))
        self.SetFinishFrame()

    def ShowExit(self):
        self.timer.Stop()
        exitFrame=ExitFrame(self)
        exitID=exitFrame.Show()

    def OnTime(self,event):
        now=GetDate()
        status=now
        self.status.SetLabel("%s"%status)

        if(GPIO.input(OK)==GPIO.LOW):
            cimage=wx.Image('/home/pi/mirs_display/img/finish_click.jpg')
            cbmp=cimage.ConvertToBitmap()
            self.button.SetBitmap(cbmp)
            self.Refresh()
            time.sleep(1)
            self.ShowExit()

    def SetFinishFrame(self):
        finishpanel=wx.Panel(self)
        statustext=GetDate()
        self.status=wx.StaticText(finishpanel,-1,statustext)
        message=wx.StaticText(finishpanel,-1,"作業が完了しました")
        image=wx.Image('/home/pi/mirs_display/img/finish_on_carsol.jpg')
        bmp=image.ConvertToBitmap()
        self.button=wx.StaticBitmap(finishpanel,-1,bmp)

        font1=wx.Font(30,wx.FONTFAMILY_DEFAULT,wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_NORMAL)
        self.status.SetFont(font1)
        font2=wx.Font(50,wx.FONTFAMILY_DEFAULT,wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_NORMAL)
        message.SetFont(font2)

        self.timer=wx.Timer(self)
        self.Bind(wx.EVT_TIMER,self.OnTime)
        self.timer.Start(200,wx.TIMER_CONTINUOUS)

        sizer=wx.GridBagSizer()
        sizer.Add(self.status,(0,0),(1,1),flag=wx.EXPAND|wx.LEFT,border=700)
        sizer.Add(message,(1,0),(1,1),flag=wx.EXPAND|wx.LEFT,border=100)
        sizer.Add(self.button,(2,0),(1,1),flag=wx.EXPAND|wx.ALL,border=50)
        sizer.AddGrowableRow(0,1)
        sizer.AddGrowableRow(1,3)
        sizer.AddGrowableRow(2,2)
        sizer.AddGrowableCol(0,1)
        finishpanel.SetSizer(sizer)
