#選択画面、確認画面
import wx
from datetime import datetime,timedelta,timezone
import time
import RPi.GPIO as GPIO

from .get_status import GetDate
from .figure_changer import FigSet,CountRight,CountLeft
from .gpio_setup import OK,LEFT,RIGHT
from .comm_snd import CommSend
from .run_frame import RunFrame

YES=1
NO=0
carsol=YES

class SelectFrame(wx.Frame):
    def __init__(self,parent):
        wx.Frame.__init__(self,parent,-1,"select")
        size=wx.ScreenDC().GetSize()
        self.SetSize(size)
        self.SetPosition(wx.Point(0,0))
        self.SetSelectFrame()

    def ShowReady(self):
        readyFrame=ReadyFrame(self)
        readyID=readyFrame.Show()

    def SetFigure(self):
        fig=FigSet()
        self.figure.SetBitmap(fig)
        self.Refresh()

    def ChangeFigLeft(self):
        CountLeft()
        self.SetFigure()

    def ChangeFigRight(self):
        CountRight()
        self.SetFigure()

    def OnTime(self,event):
        #時計関係
        now=GetDate()
        status=now
        self.status.SetLabel("%s"%status)

        #GPIO入力関係
        if(GPIO.input(OK)==GPIO.LOW):
            self.timer.Stop()
            self.ShowReady()
            time.sleep(0.2)
        elif(GPIO.input(RIGHT)==GPIO.LOW):
            self.ChangeFigRight()
            time.sleep(0.2)
        elif(GPIO.input(LEFT)==GPIO.LOW):
            self.ChangeFigLeft()
            time.sleep(0.2)
        else:
            pass

    def SetSelectFrame(self):
        selectpanel=wx.Panel(self)
        statustext=GetDate()
        self.status=wx.StaticText(selectpanel,-1,statustext)
        text1=wx.StaticText(selectpanel,-1,"図面を選択してください")
        fig=FigSet()
        self.figure=wx.StaticBitmap(selectpanel,-1,fig)
        blank2=wx.StaticText(selectpanel,-1,"")
        blank3=wx.StaticText(selectpanel,-1,"")
        image_l=wx.Image('/home/pi/mirs_display/img/left.jpg')
        bmp_l=image_l.ConvertToBitmap()
        button_l=wx.StaticBitmap(selectpanel,-1,bmp_l)
        image_r=wx.Image('/home/pi/mirs_display/img/right.jpg')
        bmp_r=image_r.ConvertToBitmap()
        button_r=wx.StaticBitmap(selectpanel,-1,bmp_r)
        blank4=wx.StaticText(selectpanel,-1,"")
        blank5=wx.StaticText(selectpanel,-1,"")
        image=wx.Image('/home/pi/mirs_display/img/select_text.jpg')
        bitmap=image.ConvertToBitmap()
        text2=wx.StaticBitmap(selectpanel,-1,bitmap)

        font1=wx.Font(30,wx.FONTFAMILY_DEFAULT,wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_NORMAL)
        self.status.SetFont(font1)
        font2=wx.Font(40,wx.FONTFAMILY_DEFAULT,wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_NORMAL)
        text1.SetFont(font2)

        self.timer=wx.Timer(self)
        self.Bind(wx.EVT_TIMER,self.OnTime)
        self.timer.Start(200,wx.TIMER_CONTINUOUS)

        sizer=wx.GridBagSizer()
        sizer.Add(self.status,(0,0),(1,3),flag=wx.EXPAND|wx.LEFT,border=700)
        sizer.Add(text1,(1,0),(1,3),flag=wx.EXPAND|wx.LEFT,border=150)
        sizer.Add(blank2,(2,0),(1,1),flag=wx.EXPAND)
        sizer.Add(self.figure,(2,1),(3,1),flag=wx.EXPAND|wx.LEFT,border=30)
        sizer.Add(blank3,(2,2),(1,1),flag=wx.EXPAND)
        sizer.Add(button_l,(3,0),(1,1),flag=wx.EXPAND|wx.LEFT,border=30)
        sizer.Add(button_r,(3,2),(1,1),flag=wx.EXPAND|wx.RIGHT,border=30)
        sizer.Add(blank4,(4,0),(1,1),flag=wx.EXPAND)
        sizer.Add(blank5,(4,2),(1,1),flag=wx.EXPAND)
        sizer.Add(text2,(5,0),(1,3),flag=wx.EXPAND)
        sizer.AddGrowableRow(0,7)
        sizer.AddGrowableRow(1,13)
        sizer.AddGrowableRow(2,25)
        sizer.AddGrowableRow(3,25)
        sizer.AddGrowableRow(4,25)
        sizer.AddGrowableRow(5,15)
        sizer.AddGrowableCol(0,1)
        sizer.AddGrowableCol(1,7)
        sizer.AddGrowableCol(2,1)
        selectpanel.SetSizer(sizer)

class ReadyFrame(wx.Frame):
    def __init__(self,parent):
        wx.Frame.__init__(self,parent,-1,"ready")
        size=wx.ScreenDC().GetSize()
        self.SetSize(size)
        self.SetPosition(wx.Point(0,0))
        global carsol
        carsol=YES
        self.SetReadyFrame()

    def ShowRun(self):
        self.timer.Stop()
        CommSend()
        runFrame=RunFrame(self)
        runID=runFrame.Show()

    def BackSelect(self):
        self.timer.Stop()
        selectFrame=SelectFrame(self)
        selectID=selectFrame.Show()

    def MoveRight(self):
        global carsol
        nimage1=wx.Image('/home/pi/mirs_display/img/yes_click.jpg')
        nbmp_y=nimage1.ConvertToBitmap()
        nimage2=wx.Image('/home/pi/mirs_display/img/no_on_carsol.jpg')
        nbmp_n=nimage2.ConvertToBitmap()
        if(carsol==YES):
            self.button_y.SetBitmap(nbmp_y)
            self.button_n.SetBitmap(nbmp_n)
            carsol=NO
            self.Refresh()

    def MoveLeft(self):
        global carsol
        if(carsol==NO):
            self.button_y.SetBitmap(self.bmp_y)
            self.button_n.SetBitmap(self.bmp_n)
            carsol=YES
            self.Refresh()

    def OnTime(self,event):
        now=GetDate()
        status=now
        self.status.SetLabel("%s"%status)

        if(GPIO.input(OK)==GPIO.LOW):
            if(carsol==YES):
                self.ShowRun()
            else:
                self.BackSelect()
        elif(GPIO.input(RIGHT)==GPIO.LOW):
            self.MoveRight()
            time.sleep(0.2)
        elif(GPIO.input(LEFT)==GPIO.LOW):
            self.MoveLeft()
            time.sleep(0.2)
        else:
            pass

    def SetReadyFrame(self):
        readypanel=wx.Panel(self)
        bitmap=FigSet()
        blank1=wx.StaticText(readypanel,-1,"")
        statustext=GetDate()
        self.status=wx.StaticText(readypanel,-1,statustext)
        message=wx.StaticText(readypanel,-1,"これで実行します")
        figure=wx.StaticBitmap(readypanel,-1,bitmap)
        image1=wx.Image('/home/pi/mirs_display/img/yes_on_carsol.jpg')
        self.bmp_y=image1.ConvertToBitmap()
        self.button_y=wx.StaticBitmap(readypanel,-1,self.bmp_y)
        image2=wx.Image('/home/pi/mirs_display/img/no_click.jpg')
        self.bmp_n=image2.ConvertToBitmap()
        self.button_n=wx.StaticBitmap(readypanel,-1,self.bmp_n)

        font1=wx.Font(30,wx.FONTFAMILY_DEFAULT,wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_NORMAL)
        self.status.SetFont(font1)
        font2=wx.Font(40,wx.FONTFAMILY_DEFAULT,wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_NORMAL)
        message.SetFont(font2)

        self.timer=wx.Timer(self)
        self.Bind(wx.EVT_TIMER,self.OnTime)
        self.timer.Start(200,wx.TIMER_CONTINUOUS)

        sizer=wx.GridBagSizer()
        sizer.Add(blank1,(0,0),(1,1),flag=wx.EXPAND)
        sizer.Add(self.status,(0,1),(1,1),flag=wx.EXPAND|wx.LEFT,border=250)
        sizer.Add(message,(1,0),(1,2),flag=wx.EXPAND|wx.LEFT,border=200)
        sizer.Add(figure,(2,0),(1,2),flag=wx.EXPAND|wx.LEFT|wx.RIGHT,border=100)
        sizer.Add(self.button_y,(3,0),(1,1),flag=wx.EXPAND|wx.LEFT|wx.RIGHT,border=50)
        sizer.Add(self.button_n,(3,1),(1,1),flag=wx.EXPAND|wx.LEFT|wx.RIGHT,border=50)
        sizer.AddGrowableRow(0,7)
        sizer.AddGrowableRow(1,15)
        sizer.AddGrowableRow(2,63)
        sizer.AddGrowableRow(3,15)
        sizer.AddGrowableCol(0,1)
        sizer.AddGrowableCol(1,1)
        readypanel.SetSizer(sizer)
